<?php

namespace App\Wrangler\Components;

use Illuminate\Http\Request;
use Medialight\Textstem\Models\WranglerPage;
use Medialight\Textstem\Wrangler\ActiveComponent;

class Article extends ActiveComponent
{
    public static string $description = 'Displays some HTML content - intended for extended blocks of content that may incude images, tables, lists and so on.';


    public $config;

    public array $editSetup = [
        [
            'name' => 'title',
            'controltype' => 'text',
            'value' => '',
            'label' => 'Title',
            'instructions' => 'Optional title. Note - this text will be escaped. To enter raw HTML, use the HTML block.',
            'size' => 3,
        ],
        [
            'name' => 'heading_level',
            'controltype' => 'select',
            'value' => 'h2',
            'options' => ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
            'label' => 'Heading Level',
            'size' => 1,
        ],
        [
            'name' => 'content',
            'controltype' => 'htmleditor',
            'value' => '',
            'label' => 'Content',
        ],
    ];

    public function render(Request $request, WranglerPage $wranglerPage)
    {
        $view = $this->getView();
        return view($view, $this->config)->render();
    }

    public function preview()
    {
        $title = $this->config['title'] ?? '';
        if ($title){
            $level = $this->config['title'] ?? 'h2';
            $title = "<$level>$title</$level>";
        }
        return $title . (string)$this->config['content'];
    }
}
